// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DBUtils.pas' rev: 6.00

#ifndef DBUtilsHPP
#define DBUtilsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <IniFiles.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Registry.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dbutils
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TLocateObject;
class PASCALIMPLEMENTATION TLocateObject : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Db::TDataSet* FDataSet;
	Db::TField* FLookupField;
	AnsiString FLookupValue;
	bool FLookupExact;
	bool FCaseSensitive;
	void *FBookmark;
	bool FIndexSwitch;
	void __fastcall SetDataSet(Db::TDataSet* Value);
	
protected:
	bool __fastcall MatchesLookup(Db::TField* Field);
	virtual void __fastcall CheckFieldType(Db::TField* Field);
	virtual void __fastcall ActiveChanged(void);
	virtual bool __fastcall LocateFilter(void);
	virtual bool __fastcall LocateKey(void);
	virtual bool __fastcall LocateFull(void);
	virtual bool __fastcall UseKey(void);
	virtual bool __fastcall FilterApplicable(void);
	__property Db::TField* LookupField = {read=FLookupField};
	__property AnsiString LookupValue = {read=FLookupValue};
	__property bool LookupExact = {read=FLookupExact, nodefault};
	__property bool CaseSensitive = {read=FCaseSensitive, nodefault};
	__property void * Bookmark = {read=FBookmark, write=FBookmark};
	
public:
	bool __fastcall Locate(const AnsiString KeyField, const AnsiString KeyValue, bool Exact, bool CaseSensitive);
	__property Db::TDataSet* DataSet = {read=FDataSet, write=SetDataSet};
	__property bool IndexSwitch = {read=FIndexSwitch, write=FIndexSwitch, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TLocateObject(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TLocateObject(void) { }
	#pragma option pop
	
};


typedef TLocateObject* __fastcall (*TCreateLocateObject)(void);

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TCreateLocateObject CreateLocateObject;
#define TrueExpr "0=0"
#define sdfStandard16 "'\"'mm'/'dd'/'yyyy'\"'"
#define sdfStandard32 "'''dd/mm/yyyy'''"
#define sdfOracle "\"TO_DATE('\"dd/mm/yyyy\"', 'DD/MM/YYYY')\""
#define sdfInterbase "\"CAST('\"mm\"/\"dd\"/\"yyyy\"' AS DATE)\""
#define sdfMSSQL "\"CONVERT(datetime, '\"mm\"/\"dd\"/\"yyyy\"', 103)\""
extern PACKAGE System::SmallString<50>  ServerDateFmt;
extern PACKAGE void __fastcall _DBError(const AnsiString Msg);
extern PACKAGE bool __fastcall ConfirmDelete(void);
extern PACKAGE void __fastcall ConfirmDataSetCancel(Db::TDataSet* DataSet);
extern PACKAGE void __fastcall RefreshQuery(Db::TDataSet* Query);
extern PACKAGE TLocateObject* __fastcall CreateLocate(Db::TDataSet* DataSet);
extern PACKAGE bool __fastcall DataSetLocateThrough(Db::TDataSet* DataSet, const AnsiString KeyFields, const Variant &KeyValues, Db::TLocateOptions Options);
extern PACKAGE bool __fastcall DataSetSortedSearch(Db::TDataSet* DataSet, const AnsiString Value, const AnsiString FieldName, bool CaseInsensitive);
extern PACKAGE AnsiString __fastcall DataSetSectionName(Db::TDataSet* DataSet);
extern PACKAGE void __fastcall InternalSaveFields(Db::TDataSet* DataSet, System::TObject* IniFile, const AnsiString Section);
extern PACKAGE void __fastcall InternalRestoreFields(Db::TDataSet* DataSet, System::TObject* IniFile, const AnsiString Section, bool RestoreVisible);
extern PACKAGE void __fastcall SaveFieldsReg(Db::TDataSet* DataSet, Registry::TRegIniFile* IniFile);
extern PACKAGE void __fastcall RestoreFieldsReg(Db::TDataSet* DataSet, Registry::TRegIniFile* IniFile, bool RestoreVisible);
extern PACKAGE void __fastcall SaveFields(Db::TDataSet* DataSet, Inifiles::TIniFile* IniFile);
extern PACKAGE void __fastcall RestoreFields(Db::TDataSet* DataSet, Inifiles::TIniFile* IniFile, bool RestoreVisible);
extern PACKAGE bool __fastcall IsDataSetEmpty(Db::TDataSet* DataSet);
extern PACKAGE AnsiString __fastcall DateToSQL(System::TDateTime Value);
extern PACKAGE AnsiString __fastcall FormatSQLDateRange(System::TDateTime Date1, System::TDateTime Date2, const AnsiString FieldName);
extern PACKAGE AnsiString __fastcall FormatSQLDateRangeEx(System::TDateTime Date1, System::TDateTime Date2, const AnsiString FieldName);
extern PACKAGE AnsiString __fastcall FormatSQLNumericRange(const AnsiString FieldName, double LowValue, double HighValue, double LowEmpty, double HighEmpty, bool Inclusive);
extern PACKAGE AnsiString __fastcall StrMaskSQL(const AnsiString Value);
extern PACKAGE AnsiString __fastcall FormatSQLCondition(const AnsiString FieldName, const AnsiString Operator, const AnsiString Value, Db::TFieldType FieldType, bool Exact);
extern PACKAGE AnsiString __fastcall FormatAnsiSQLCondition(const AnsiString FieldName, const AnsiString Operator, const AnsiString Value, Db::TFieldType FieldType, bool Exact);
extern PACKAGE void __fastcall CheckRequiredField(Db::TField* Field);
extern PACKAGE void __fastcall CheckRequiredFields(const Db::TField* * Fields, const int Fields_Size);
extern PACKAGE void __fastcall AssignRecord(Db::TDataSet* Source, Db::TDataSet* Dest, bool ByName);

}	/* namespace Dbutils */
using namespace Dbutils;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DBUtils
