// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RXClock.pas' rev: 6.00

#ifndef RXClockHPP
#define RXClockHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <RTLConsts.hpp>	// Pascal unit
#include <RxTimer.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxclock
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TShowClock { scDigital, scAnalog };
#pragma option pop

#pragma option push -b-
enum TPaintMode { pmPaintAll, pmHandPaint };
#pragma option pop

#pragma pack(push, 1)
struct TRxClockTime
{
	Word Hour;
	Word Minute;
	Word Second;
} ;
#pragma pack(pop)

typedef void __fastcall (__closure *TRxGetTimeEvent)(System::TObject* Sender, System::TDateTime &ATime);

class DELPHICLASS TRxClock;
class PASCALIMPLEMENTATION TRxClock : public Extctrls::TCustomPanel 
{
	typedef Extctrls::TCustomPanel inherited;
	
private:
	Rxtimer::TRxTimer* FTimer;
	bool FAutoSize;
	TShowClock FShowMode;
	bool FTwelveHour;
	bool FLeadingZero;
	bool FShowSeconds;
	System::TDateTime FAlarm;
	bool FAlarmEnabled;
	bool FHooked;
	Graphics::TColor FDotsColor;
	bool FAlarmWait;
	#pragma pack(push, 1)
	TRxClockTime FDisplayTime;
	#pragma pack(pop)
	
	#pragma pack(push, 1)
	Types::TRect FClockRect;
	#pragma pack(pop)
	
	int FClockRadius;
	#pragma pack(push, 1)
	Types::TPoint FClockCenter;
	#pragma pack(pop)
	
	TRxGetTimeEvent FOnGetTime;
	Classes::TNotifyEvent FOnAlarm;
	void __fastcall TimerExpired(System::TObject* Sender);
	void __fastcall GetTime(TRxClockTime &T);
	bool __fastcall IsAlarmTime(System::TDateTime ATime);
	void __fastcall SetShowMode(TShowClock Value);
	Byte __fastcall GetAlarmElement(int Index);
	void __fastcall SetAlarmElement(int Index, Byte Value);
	void __fastcall SetDotsColor(Graphics::TColor Value);
	void __fastcall SetTwelveHour(bool Value);
	void __fastcall SetLeadingZero(bool Value);
	void __fastcall SetShowSeconds(bool Value);
	void __fastcall PaintAnalogClock(TPaintMode PaintMode);
	void __fastcall Paint3DFrame(Types::TRect &Rect);
	void __fastcall DrawAnalogFace(void);
	void __fastcall CircleClock(int MaxWidth, int MaxHeight);
	void __fastcall DrawSecondHand(int Pos);
	void __fastcall DrawFatHand(int Pos, bool HourHand);
	void __fastcall PaintTimeStr(Types::TRect &Rect, bool FullTime);
	void __fastcall ResizeFont(const Types::TRect &Rect);
	void __fastcall ResetAlarm(void);
	void __fastcall CheckAlarm(void);
	bool __fastcall FormatSettingsChange(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMCtl3DChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMTextChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall WMTimeChange(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall SetAutoSize(bool Value);
	DYNAMIC void __fastcall Alarm(void);
	virtual void __fastcall AlignControls(Controls::TControl* AControl, Types::TRect &Rect);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall DestroyWindowHandle(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Paint(void);
	virtual System::TDateTime __fastcall GetSystemTime(void);
	
public:
	__fastcall virtual TRxClock(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxClock(void);
	void __fastcall SetAlarmTime(System::TDateTime AlarmTime);
	void __fastcall UpdateClock(void);
	
__published:
	__property bool AlarmEnabled = {read=FAlarmEnabled, write=FAlarmEnabled, default=0};
	__property Byte AlarmHour = {read=GetAlarmElement, write=SetAlarmElement, index=1, default=0};
	__property Byte AlarmMinute = {read=GetAlarmElement, write=SetAlarmElement, index=2, default=0};
	__property Byte AlarmSecond = {read=GetAlarmElement, write=SetAlarmElement, index=3, default=0};
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, default=0};
	__property BevelInner  = {default=1};
	__property BevelOuter  = {default=2};
	__property Graphics::TColor DotsColor = {read=FDotsColor, write=SetDotsColor, default=8421376};
	__property TShowClock ShowMode = {read=FShowMode, write=SetShowMode, default=0};
	__property bool ShowSeconds = {read=FShowSeconds, write=SetShowSeconds, default=1};
	__property bool TwelveHour = {read=FTwelveHour, write=SetTwelveHour, default=0};
	__property bool LeadingZero = {read=FLeadingZero, write=SetLeadingZero, default=1};
	__property Align  = {default=0};
	__property BevelWidth  = {default=1};
	__property BorderWidth  = {default=0};
	__property BorderStyle  = {default=0};
	__property Anchors  = {default=3};
	__property Constraints ;
	__property UseDockManager  = {default=1};
	__property DockSite  = {default=0};
	__property DragKind  = {default=0};
	__property FullRepaint  = {default=1};
	__property Color  = {default=-2147483633};
	__property Ctl3D ;
	__property Cursor  = {default=0};
	__property DragMode  = {default=0};
	__property DragCursor  = {default=-12};
	__property Enabled  = {default=1};
	__property Font ;
	__property ParentColor  = {default=0};
	__property ParentCtl3D  = {default=1};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible  = {default=1};
	__property Classes::TNotifyEvent OnAlarm = {read=FOnAlarm, write=FOnAlarm};
	__property TRxGetTimeEvent OnGetTime = {read=FOnGetTime, write=FOnGetTime};
	__property OnClick ;
	__property OnDblClick ;
	__property OnMouseMove ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnDragOver ;
	__property OnDragDrop ;
	__property OnEndDrag ;
	__property OnResize ;
	__property OnContextPopup ;
	__property OnStartDrag ;
	__property OnCanResize ;
	__property OnConstrainedResize ;
	__property OnDockDrop ;
	__property OnDockOver ;
	__property OnEndDock ;
	__property OnGetSiteInfo ;
	__property OnStartDock ;
	__property OnUnDock ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TRxClock(HWND ParentWindow) : Extctrls::TCustomPanel(ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Rxclock */
using namespace Rxclock;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RXClock
